
#define TRUE 1
#define FALSE 0

#ifdef _WIN32_WINNT
#define strncasecmp strnicmp
#endif

#define ALPHA(x) ((x >= 'a' && x <= 'z') || (x >= 'A' && x <= 'Z'))
#define WHITESPACE(x) (x == ' ' || x == '\t' )
#define  IS_SPACE(x) (x == ' ' || x == '\t' || x == '\r' || x == '\n')

#define REWRITE2_STATE_START    0x00            /* Not in the interesting tag block */
#define REWRITE2_STATE_INTEREST 0x01            /* In the interesting tag block     */
#define REWRITE2_STATE_ABORT    0xff            /* the rewrite2 is aborted          */

/* For 2-bytes coded html page, we assuming the first byte is greater than 128 */
#define SPECIAL(x) ((unsigned char)x > 128)

#define STATE_NONE        0
#define STATE_LEFT        1
#define STATE_RIGHT       2

#define BUFFER_BASE_SIZE  2048
#define BUFFER_LIMIT      16384


/* write a char onto output stream */
extern int WRITE_OUTPUT(unsigned char* handle, 
                        unsigned char** outputpp,  
                        unsigned long* outSizep, 
                        unsigned long* outCountp, 
                        unsigned char c);

/* Flush the buffered output stream */
extern int FLUSH_OUTPUT(unsigned char* handle, 
                        unsigned char** outputpp,  
                        unsigned long* outSizep,  
                        unsigned long* outCountp);

/* The dispatch handler */
extern long rewrite2_handle(unsigned char* handle,
                            unsigned char* input,
                            unsigned long* len,
                            unsigned char* prefix);

/* The script block handler */
extern long script_handler(unsigned char* handle,
                        unsigned char* prefix,
                        unsigned char* input,
                        unsigned long  inSize,
                        unsigned char** outputpp,
                        unsigned long* outSizep,
                        unsigned long* outCountp);

/* The applet block handler */
extern long applet_handler(unsigned char* handle,
                        unsigned char* prefix,
                        unsigned char* input,
                        unsigned long  inSize,
                        unsigned char** outputpp,
                        unsigned long* outSizep,
                        unsigned long* outCountp);

